/* AP 05-04-00 frontend to COM calculator		*/
/*    18-01-01 create 2 COM objects	with state	*/

# include <stdio.h>
# include "Calculator.h"


/* include type and constant definitions */
# include "Calculator_i.c"

main (int argc, char ** argv ) {
	int x = 0, y = 0, z = 0, i = 0;
	
	if (argc-- > 1) x = atoi(argv[++i]);
	if (argc-- > 1) y = atoi(argv[++i]);
	
	IUnknown	*pUnknown;
	ICalc		*pCalc, *pCalc2;
	HRESULT		hr;
	
	CoInitialize( NULL );
	hr = CoCreateInstance( CLSID_Calc, NULL, CLSCTX_SERVER, IID_IUnknown, (void **) &pUnknown );
	if (FAILED(hr)) {
		printf("Could not create Calculator Component, exiting...\n");
		exit(1);
	}
	pUnknown->QueryInterface( IID_ICalc, (void **) &pCalc );
	pUnknown->Release();

	CoCreateInstance( CLSID_Calc, NULL, CLSCTX_SERVER, IID_IUnknown, (void **) &pUnknown );
	pUnknown->QueryInterface( IID_ICalc, (void **) &pCalc2 );
	pUnknown->Release();

	pCalc->Add( x, y, &z );
	printf("pCalc->Add( %d, %d ) returns: %d \n", x, y, z );
	pCalc->getMem( &z );
	printf("pCalc->getMem() returns: %d \n", z );

	pCalc2->Mult( x, y, &z );
	printf("pCalc2->Mult( %d, %d ) returns: %d \n", x, y, z );
	pCalc2->getMem( &z );
	printf("pCalc2->getMem() returns: %d \n", z );

	pCalc->Release();
	pCalc2->Release();
	CoUninitialize();

	return 0;
}